
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>学习ASP.NET Core,怎能不了解请求处理管道[1]: 中间件究竟是个什么东西？ / iVAN</title>

    <meta name="description" content="学习ASP.NET Core,怎能不了解请求处理管道[1]: 中间件究竟是个什么东西？ ASP.NET Core管道虽然在结构组成上显得非常简单,但是在具体实现上却涉及到太多的对象,所以我们在 &quot;通过重建Hosting系统理解HTTP请求在ASP.NET Core管道中的处理流程&quot;(上篇.中篇.下篇) 中围绕着一个经过极度简化的模拟管道讲述了真实管道构建的方式以及处理HTTP请求的流程.在本系列 中,我们会还原构建模拟管道时可以舍弃和改写的部分,向读者朋友们呈现一个真是的HTTP请求处理管道. ASP.NET Core 的请求处理管道由一个服务器与一组有序排列的 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">学习ASP.NET Core,怎能不了解请求处理管道[1]: 中间件究竟是个什么东西？</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>ASP.NET Core管道虽然在结构组成上显得非常简单，但是在具体实现上却涉及到太多的对象，所以我们在 “通过重建Hosting系统理解HTTP请求在ASP.NET Core管道中的处理流程”（<a href="http://www.cnblogs.com/artech/p/rebuild-pipeline-01.html" rel="external nofollow noreferrer">上篇</a>、<a href="http://www.cnblogs.com/artech/p/rebuild-pipeline-02.html" rel="external nofollow noreferrer">中篇</a>、<a href="http://www.cnblogs.com/artech/p/rebuild-pipeline-03.html" rel="external nofollow noreferrer">下篇</a>）<br />
 中围绕着一个经过极度简化的模拟管道讲述了真实管道构建的方式以及处理HTTP请求的流程。在本系列<br />
中，我们会还原构建模拟管道时可以舍弃和改写的部分，向读者朋友们呈现一个真是的HTTP请求处理管道。 ASP.NET Core<br />
的请求处理管道由一个服务器与一组有序排列的中间件构成，前者仅仅完成请求监听、接收和响应这些与底层网络相关的工作，至于请求接收之后和响应之前的所有工作都交给中间件来完成。ASP.NET<br />
 Core的中间件通过一个类型Func&lt;RequestDelegate, RequestDelegate&gt;的委托对象来表示，而RequestDelegate也是一个委托，它代表一项请求处理任务。 [本文已经同步到《<a href="http://www.cnblogs.com/artech/p/inside-asp-net-core-1.html" rel="external nofollow noreferrer">ASP.NET Core框架揭秘</a>》之中]</p>
<blockquote><p>目录<br />
一、RequestDelegate<br />
二、HttpContext<br />
    FeatureCollection<br />
    DefaultHttpContext<br />
    HttpContextFactory<br />
三、ApplicationBuilder<br />
    ApplicationBuilderFactory<br />
    中间件类型<br />
    中间件类型的注册</p></blockquote>
<h1>一、RequestDelegate</h1>
<p>服务器接受到抵达的HTTP请求之后会构建一个描述当前请求的原始上下文，服务器的类型决定了这个原始上下文的类型，比如在我们模拟管道默认采用的HttpListenerServer由于采用HttpListener来监听、接收并响应请求，所以它对应的原始上下文是一个HttpListenerContext对象。但是对于管道的后续部分，即由注册的中间件构建的链表，它们需要采用统一的方式来处理请求，所以服务器最终会根据原始的上下文来创建一个抽象的HTTP上下文，后者通过抽象类HttpContext来表示。</p>
<p>我们不仅可以利用这个HttpContext获取描述当前请求的上下文信息，同样可以利用它来实现对响应的控制。针对当前请求的任何处理操作总是在这么一个上下文中进行，所以一项请求处理任务完全可以抽象成一个类型Func&lt;HttpContext,Task&gt;的委托来表示，实际上具有如下定义的RequestDelegate委托具有类似的定义。</p>
<pre>   1: public delegate Task RequestDelegate(HttpContext context); </pre>
<p>每个中间件都承载着独立的请求处理任务，它本质上也体现了在当前HttpContext下针对请求的处理操作，那么为什么中间件不直接通过一个RequestDelegate对象来表示，而是表示为一个类型为Func&lt;RequestDelegate,</p>
<p>RequestDelegate&gt;的委托对象呢？原因很简单，中间件并不孤立地存在，所有注册的中间件最终会根据注册的先后顺序组成一个链表，每个中间件不仅仅需要完成各自的请求处理任务外，还需要驱动链表中的下一个中间件。</p>
<p><a href="http://images2015.cnblogs.com/blog/19327/201611/19327-20161114083643607-232991122.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE5MzI3LzIwMTYxMS8xOTMyNy0yMDE2MTExNDA4MzY0Mzg3My0xMzU2Njk3MDQ0LnBuZw==.jpg"></a></p>
<p>如上图所示，对于一个由多个Func&lt;RequestDelegate,<br />
RequestDelegate&gt;对象组成的中间链表来说，某个中间件会将后一个Func&lt;RequestDelegate,<br />
RequestDelegate&gt;对象的返回值作为输入，而自身的返回值则作为前一个中间件的输入。某个中间件执行之后返回的RequestDelegate对象不仅仅体现了自身对请求的处理操作，而是体现了包含自己和后续中间件一次对请求的处理。那么对于第一个中间件来说，它执行后返回的RequestDelegate对象实际上体现了整个应用对请求的处理逻辑。</p>
<h1>二、 HttpContext</h1>
<p>对当前上下文的抽象解除了管道对具体服务器类型的依赖， 这使我们可以为ASP.NET<br />
Core应用自由地选择承载（Hosting）方式，而不是像传统的ASP.NET应用一样只能寄宿在IIS之中。抽象HTTP上下文的目的是为了实现对请求处理流程的抽象，只有这样我们才能将针对请求的某项操作体现在一个标准的中间件上，有了这个这个标准化的中间件才有所谓的请求处理管道。</p>
<p>ASP.NET<br />
Core通过具有如下所示的HttpContext类来表示这么一个抽象的HTTP上下文。对于一个HttpContext对象来说，它的核心体现在用于描述请求和响应的Request和Response属性之上。除此之外，我们还可以通过它获取与当前请求相关的其他上下文信息，比如用来控制用户认证的AuthenticationManager对象和代表当前请求用户的ClaimsPrincipal对象，以及描述当前HTTP连接的ConnectionInfo对象和用于控制WebSocket的WebSocketManager。我们可以获取并控制当前会话，也可以获取或者设置调试追踪的ID。</p>
<pre>   1: public abstract class HttpContext</pre>
<pre>   2: {</pre>
<pre>   3:  </pre>
<pre>   4:     public abstract HttpRequest     Request { get; }</pre>
<pre>   5:     public abstract HttpResponse    Response { get; }</pre>
<pre>   6:  </pre>
<pre>   7:     public abstract AuthenticationManager            Authentication { get; }</pre>
<pre>   8:     public abstract ClaimsPrincipal                  User { get; set; }</pre>
<pre>   9:     public abstract ConnectionInfo                   Connection { get; } </pre>
<pre>  10:     public abstract WebSocketManager                 WebSockets { get; } </pre>
<pre>  11:     public abstract ISession                         Session { get; set; } </pre>
<pre>  12:     public abstract string                           TraceIdentifier { get; set; }</pre>
<pre>  13:     public abstract CancellationToken                RequestAborted { get; set; }  </pre>
<pre>  14:     public abstract IDictionary&lt;object, object&gt;      Items { get; set; }  </pre>
<pre>  15:  </pre>
<pre>  16:     public abstract IServiceProvider                RequestServices { get; set; }</pre>
<pre>  17:     public abstract IFeatureCollection              Features { get; }</pre>
<pre>  18: }</pre>
<p>当需要中指对请求的处理时，我们可以通过为RequestAborted属性设置一个CancellationToken对象从而将终止通知发送给管道。如果需要对整个管道共享一些与当前上下文相关的数据，我们可以将它保存在通过Items属性表示的字典中。我们一再提到依赖注入被广泛地应用ASP.NET</p>
<p>Core管道中，HttpContext的RequestServices属性返回的根据在应用启动时注册的服务而创建的ServiceProvider。只要相应的服务被预先注册到指定的服务接口上，我们就可能利用这个ServiceProvider根据这个接口得到对应的服务对象。</p>
<pre>   1: public abstract class HttpRequest</pre>
<pre>   2: {</pre>
<pre>   3:     public abstract HttpContext                    HttpContext { get; }</pre>
<pre>   4:     public abstract string                         Method { get; set; }</pre>
<pre>   5:     public abstract string                         Scheme { get; set; }</pre>
<pre>   6:     public abstract bool                           IsHttps { get; set; }</pre>
<pre>   7:     public abstract HostString                     Host { get; set; }</pre>
<pre>   8:     public abstract PathString                     PathBase { get; set; }</pre>
<pre>   9:     public abstract PathString                     Path { get; set; }</pre>
<pre>  10:     public abstract QueryString                    QueryString { get; set; }</pre>
<pre>  11:     public abstract IQueryCollection               Query { get; set; }</pre>
<pre>  12:     public abstract string                         Protocol { get; set; }</pre>
<pre>  13:     public abstract IHeaderDictionary              Headers { get; } &gt;</pre>
<pre>  14:     public abstract IRequestCookieCollection       Cookies { get; set; }</pre>
<pre>  15:     public abstract string                         ContentType { get; set; }</pre>
<pre>  16:     public abstract Stream                         Body { get; set; }</pre>
<pre>  17:     public abstract bool                           HasFormContentType { get; }</pre>
<pre>  18:     public abstract IFormCollection                Form { get; set; }</pre>
<pre>  19:  </pre>
<pre>  20:     public abstract Task&lt;IFormCollection&gt;         ReadFormAsync(CancellationToken cancellationToken);</pre>
<pre>  21: }</pre>
<p>如上所示的是抽象类HttpRequest是对HTTP请求的描述，它是HttpContext的只读属性Request的返回类型。我们可以利用这个对象获取到描述当前请求的各种相关信息，比如请求的协议（HTTP或者HTTPS）、HTTP方法、地址，也可以获取代表请求的HTTP消息的首部和主体。</p>
<p>在了解了表示请求的抽象类HttpRequest之后，我们再来认识一个与之相对的用于描述响应HttpResponse类型。如下面的代码片断所示，HttpResponse依然是一个抽象类，我们可以通过定义在它之上的属性和方法来控制对请求的响应。从原则上讲，我们对请求的所做的任意类型的响应都可以利用它来说实现。当我们通过表示当前上下文的HttpContext对象得到表示响应的HttpResponse之后，我们不仅仅可以将希望的内容写入响应消息的主体，还可以设置响应状态码以及添加相应的首部。</p>
<pre>   1: public abstract class HttpResponse</pre>
<pre>   2: {</pre>
<pre>   3:     public abstract HttpContext           HttpContext { get; }</pre>
<pre>   4:     public abstract int                   StatusCode { get; set; }</pre>
<pre>   5:     public abstract IHeaderDictionary     Headers { get; }</pre>
<pre>   6:     public abstract Stream                Body { get; set; }</pre>
<pre>   7:     public abstract long?                 ContentLength { get; set; }</pre>
<pre>   8:     public abstract IResponseCookies      Cookies { get; }</pre>
<pre>   9:     public abstract bool                  HasStarted { get; }</pre>
<pre>  10:  </pre>
<pre>  11:     public abstract void OnStarting(Func&lt;object, Task&gt; callback, object state);</pre>
<pre>  12:     public virtual void OnStarting(Func&lt;Task&gt; callback);</pre>
<pre>  13:     public abstract void OnCompleted(Func&lt;object, Task&gt; callback, object state);</pre>
<pre>  14:     public virtual void RegisterForDispose(IDisposable disposable);</pre>
<pre>  15:     public virtual void OnCompleted(Func&lt;Task&gt; callback);</pre>
<pre>  16:     public virtual void Redirect(string location);</pre>
<pre>  17:     public abstract void Redirect(string location, bool permanent);</pre>
<pre>  18: }</pre>
<h2>FeatureCollection</h2>
<p>HttpContext的另一个只读属性Features返回一组“特性”对象。在ASP.NET<br />
Core管道式处理设计中，特性是一个非常重要的概念，特性是实现抽象化HttpContext的途径。具体来说，服务器在接收到请求之后会创建一个由自身类型决定的原始的上下文，管道不仅仅利用这个原始上下文来获取与请求相关的信息，它对请求的最终响应实际上也是通过这个原始上下文来完成的。所以对一个HttpContext对象来说，由它描述的上下文信息不仅仅来源于这个原始的上下文，我们针对HttpContext所做的任何响应操作最终都需要分发给这个原始上下文来完成，<br />
 否则是不会生效的。抽象的HttpContext和原始上下文之间的“双向绑定”究竟是如何实现的呢？</p>
<p>这个所谓的“双向绑定”即使其实很简单。当原始上下文被创建出来之后，服务器会将它封装成一系列标准的特性对象，HttpContext正是对这些特性对象的封装。一般来说，这些特性对象所对应的类型均实现了某个预定义的标准接口，接口中不仅仅定义相应的属性来读写原始上下文中描述的信息，还定义了相应的方法来操作原始上下文。HttpContext的属性Features返回的就是这组特性对象的集合，它的返回类型为IFeatureCollection，我们将实现了该接口的类型以及对应的对象统称为FeatureCollection。</p>
<pre>   1: public interface IFeatureCollection : IEnumerable&lt;KeyValuePair&lt;Type, object&gt;&gt;</pre>
<pre>   2: {</pre>
<pre>   3:     TFeature Get&lt;TFeature&gt;();</pre>
<pre>   4:     void Set&lt;TFeature&gt;(TFeature instance);</pre>
<pre>   5:  </pre>
<pre>   6:     bool       IsReadOnly { get; }</pre>
<pre>   7:     object     this[Type key] { get; set; }</pre>
<pre>   8:     int        Revision { get; }
   9:  }</pre>
<p>一个FeatureCollection对象本质上就是一个Key和Value分别为Type和Object类型的字段，话句话说，特性对象通过对应的接口类型注册到HttpContext之上。我们通过调用Set方法将一个特性对象针对指定的类型（一般为特性接口）注册到这个字典对象上，并通过Get方法根据注册的类型获取它。特性对象的注册和获取也可以利用定义的索引来完成。如果IsReadOnly属性返回True，我们将不能注册新的特性或者修改已经注册的特性。</p>
<p>整数类型的之都属性Revision可以视为整个FeatureCollection对象的版本，不论是采用何种方式注册新的特性还是修改现有的特性，这个属性的值都将改变。</p>
<p>具有如下定义的FeatureCollection类实现了IFeatureCollection接口，我们默认使用的FeatureCollection就是这么一个类型的对象。FeatureCollection具有两个构造函数重载，默认无参构造函数帮助我们创建一个空的特性集合，另一个构造函数则需要指定一个FeatureCollection对象来提供默认特性。对于采用第二个构造函数重载创建的</p>
<p>FeatureCollection对象来说，当我们通过指定某个特性接口类型试图获取对应的特性对象时，如果对应的特性没有注册到当前FeatureCollection对象上，而是注册到提供默认特性的FeatureCollection对象上，后者将会提供最终的特性。</p>
<pre>   1: public class FeatureCollection : IFeatureCollection</pre>
<pre>   2: {   </pre>
<pre>   3:     //其他成员</pre>
<pre>   4:     public FeatureCollection();</pre>
<pre>   5:     public FeatureCollection(IFeatureCollection defaults);</pre>
<pre>   6: }</pre>
<p>对于FeatureCollection类型来说，它<br />
的IsReadOnly总是返回False，所以它永远是可读可写的。对于调用默认无参构造函数创建的FeatureCollection对象来说，它<br />
的Revision默认返回零。如果我们通过指定另一个FeatureCollection对象为参数调用第二个构造函数来创建一个FeatureCollection对象，前者的Revision属性值将成为后者同名属性的默认值。不论我们采用何种形式（调用Set方法或者索引）添加一个新的特性或者改变了一个已经注册的特性，FeatureCollection对象的Revision属性都将自动递增。上述的这些关于FeatureCollection的特性都体现在如下所示的代码片段中。</p>
<pre>   1: FeatureCollection defaults = new FeatureCollection();</pre>
<pre>   2: Debug.Assert(defaults.Revision == 0);</pre>
<pre>   3:  </pre>
<pre>   4: defaults.Set&lt;IFoo&gt;(new Foo());</pre>
<pre>   5: Debug.Assert(defaults.Revision == 1);</pre>
<pre>   6:  </pre>
<pre>   7: defaults[typeof(IBar)] = new Bar();</pre>
<pre>   8: Debug.Assert(defaults.Revision == 2);</pre>
<pre>   9:  </pre>
<pre>  10: FeatureCollection features = new FeatureCollection(defaults);</pre>
<pre>  11: Debug.Assert(features.Revision == 2);</pre>
<pre>  12: Debug.Assert(features.Get&lt;IFoo&gt;().GetType() == typeof(Foo));</pre>
<pre>  13:  </pre>
<pre>  14: features.Set&lt;IBaz&gt;(new Baz());</pre>
<pre>  15: Debug.Assert(features.Revision == 3);</pre>
<h2>DefaultHttpContext</h2>
<p>ASP.NET<br />
Core默认使用的HttpContext类型为DefaultHttpContext，上面我们介绍的针对描述原始上下文“特性集合”来创建HttpContext的策略就体现在这个类型之上。DefaultHttpContext具有一个如下的构造函数，作为参数的FeatureCollection对象就是这么一个特性集合。</p>
<pre>   1: public class DefaultHttpContext : HttpContext</pre>
<pre>   2: {</pre>
<pre>   3:     public DefaultHttpContext(IFeatureCollection features);</pre>
<pre>   4: }</pre>
<p>不论是组成管道的中间件还是建立在管道上的应用，在默认的情况下都是利用这个DefaultHttpContext对象来获取当前请求的相关信息，并利用这个对象来控制最终发送的响应。但是DefaultHttpContext对象这个这个过程中仅仅是一个“代理”，针对它的调用（属性或者方法）最终都需要转发给由具体服务器创建的那个原始上下文，在构造函数中指定的这个FeatureCollection对象所代表的特性集合成为了这两个上下文对象进行沟通的唯一渠道。对于定义在DefaultHttpContext中的所有属性，它们几乎都具有一个对应的特性，这些特性都对应着一个接口。表1列出了部分特性接口以及DefaultHttpContext对应的属性。</p>
<p><strong>表1 </strong><strong>描述原始HTTP</strong><strong>上下文的特性接口</strong></p>
<table>
<tbody>
<tr>
<td>
<br /><strong>接口</strong></p>
</td>
<td>
<br /><strong>属性</strong></p>
</td>
<td>
<br /><strong>描述</strong><strong></strong></p>
</td>
</tr>
<tr>
<td>
<br />IHttpRequestFeature</p>
</td>
<td>
<br />Request</p>
</td>
<td>
<br />获取描述请求的基本信息。</p>
</td>
</tr>
<tr>
<td>
<br />IHttpResponseFeature</p>
</td>
<td>
<br />Response</p>
</td>
<td>
<br />控制对请求的响应。</p>
</td>
</tr>
<tr>
<td>
<br />IHttpAuthenticationFeature</p>
</td>
<td>
<br />AuthenticationManger/User</p>
</td>
<td>
<br />提供完成用户认证的AuthenticationHandler对象和表示当前用户的ClaimsPrincipal对象</p>
</td>
</tr>
<tr>
<td>
<br />IHttpConnectionFeature</p>
</td>
<td>
<br />Connection</p>
</td>
<td>
<br />提供描述当前HTTP连接的基本信息。</p>
</td>
</tr>
<tr>
<td>
<br />IItemsFeature</p>
</td>
<td>
<br />Items</p>
</td>
<td>
<br />提供用户存放针对当前请求的对象容器。</p>
</td>
</tr>
<tr>
<td>
<br />IHttpRequestLifetimeFeature</p>
</td>
<td>
<br />RequestAborted</p>
</td>
<td>
<br />传递请求处理取消通知和中止当前请求处理。</p>
</td>
</tr>
<tr>
<td>
<br />IServiceProvidersFeature</p>
</td>
<td>
<br />RequestServices</p>
</td>
<td>
<br />提供根据服务注册创建的ServiceProvider。</p>
</td>
</tr>
<tr>
<td>
<br />ISessionFeature</p>
</td>
<td>
<br />Session</p>
</td>
<td>
<br />提供描述当前会话的Session对象。</p>
</td>
</tr>
<tr>
<td>
<br />IHttpRequestIdentifierFeature</p>
</td>
<td>
<br />TraceIdentifier</p>
</td>
<td>
<br />为追踪日志（Trace）提供针对当前请求的唯一标识。</p>
</td>
</tr>
<tr>
<td>
<br />IHttpWebSocketFeature</p>
</td>
<td>
<br />WebSockets</p>
</td>
<td>
<br />管理WebSocket</p>
</td>
</tr>
</tbody>
</table>
<p>对于上面列出的众多特性接口，我们在后续相关章节中都会涉及到，目前来说我们只需要了解一下两个最重要的特性接口，即表示请求和响应的IHttpRequestFeature和IHttpResponseFeature。从下面给出的代码片断我们不难看出，这两个接口的定义分别与抽象类HttpRequest和HttpResponse具有一致的定义。对于DefaultHttpContext类型来说，它的Request和Response属性分别返回的是一个DefaultHttpRequest和DefaultHttpResponse对象。DefaultHttpRequest和DefaultHttpResponse分别继承自HttpRequest和HttpResponse，它们分别利用这个两个特性实现了从基类继承下来的所有抽象成员。</p>
<pre>   1: public interface IHttpRequestFeature</pre>
<pre>   2: {</pre>
<pre>   3:     Stream             Body { get; set; }</pre>
<pre>   4:     IHeaderDictionary  Headers { get; set; }</pre>
<pre>   5:     string             Method { get; set; }</pre>
<pre>   6:     string             Path { get; set; }</pre>
<pre>   7:     string             PathBase { get; set; }</pre>
<pre>   8:     string             Protocol { get; set; }</pre>
<pre>   9:     string             QueryString { get; set; }</pre>
<pre>  10:     string             Scheme { get; set; }</pre>
<pre>  11: }</pre>
<pre>  12:  </pre>
<pre>  13: public interface IHttpResponseFeature</pre>
<pre>  14: {</pre>
<pre>  15:     Stream             Body { get; set; }</pre>
<pre>  16:     bool               HasStarted { get; }</pre>
<pre>  17:     IHeaderDictionary  Headers { get; set; }</pre>
<pre>  18:     string             ReasonPhrase { get; set; }</pre>
<pre>  19:     int                 StatusCode { get; set; }</pre>
<pre>  20:  </pre>
<pre>  21:     void OnCompleted(Func&lt;object, Task&gt; callback, object state);</pre>
<pre>  22:     void OnStarting(Func&lt;object, Task&gt; callback, object state);</pre>
<pre>  23: }</pre>
<p>对于实现请求监听、接收和响应的服务器来说，它们都需要通过实现上面这些特性接口来定义针对性的特性类。如下图所示，当成功接收到请求之后，服务器会创建相应的特性并将它们组合成一个FeatureCollection对象，最后创建出一个DefaultHttpContext对象，我们注册的所有中间件针对这个DefaultHttpContext完成各自的请求处理工作。</p>
<p><a href="http://images2015.cnblogs.com/blog/19327/201611/19327-20161114083441029-521234949.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE5MzI3LzIwMTYxMS8xOTMyNy0yMDE2MTExNDA4MzQ0MTQ2Ny0xNzcxOTA3ODA4LnBuZw==.jpg"></a></p>
<h2>HttpContextFactory</h2>
<p>在服务器接收到抵达的请求时，它并不会直接利用原始的上下文去创建HttpContext对象，HttpContext在管道中的创建是间接地通过HttpContextFactory来完成的。</p>
<p>HttpContextFactory是对所有实现了IHttpContextFactory接口的所有类型及其对象的统称。如下面的代码片段所示，IHttpContextFactory接口除了定义创建HttpContext对象的Create方法之外，还定义了另一个方法Dispose来释放指定的HttpContext对象。HttpContextFactory类是该接口的默认实现者，由它的Create方法创建并返回的自然是一个DefaultHttpContext对象。</p>
<pre>   1: public interface IHttpContextFactory</pre>
<pre>   2: {</pre>
<pre>   3:     HttpContext Create(IFeatureCollection featureCollection);</pre>
<pre>   4:     void Dispose(HttpContext httpContext);</pre>
<pre>   5: }</pre>
<pre>   6:  </pre>
<pre>   7: public class HttpContextFactory : IHttpContextFactory</pre>
<pre>   8: {    </pre>
<pre>   9:     //省略其他成员</pre>
<pre>  10:     public HttpContext Create(IFeatureCollection featureCollection);</pre>
<pre>  11:     public void Dispose(HttpContext httpContext);</pre>
<pre>  12: }</pre>
<p>综上所述，组成管道的所有中间件在一个标准化的上下文中完整对请求的处理，这个上下文通过抽象类HttpContext表示，ASP.NET<br />
Core默认使用的是它的子类DefaultHttpContext。一个DefaultHttpContext对象是根据描述原始上下文的特性集合，每个特性对应的类型都实现了标准的接口，接口IHttpRequestFeature和IHttpResponseFeature分别代表针对请求和响应的特性。HttpContext默认情况下是通过注册的工厂创建的，该工厂通过接口IHttpContextFactory表示，默认使用的HttpContext工厂类型为HttpContextFactory，它也是DefaultHttpContext对象的创建者。</p>
<h1>三、ApplicationBuilder</h1>
<p>以类型为Func&lt;RequestDelegate,<br />
RequestDelegate&gt;的委托对象表示的中间件需要在启动的时候注册到应用程序上。所有注册的中间件最终会转换成一个RequestDelegate类型的委托对象，它们按照注册顺序对请求的处理流程最终体现在对这个委托对象的执行。不论是最终将中间件转换成RequestDelegate对象，还是最初对它们的注册，都是通过一个名为ApplicationBuilder的对象来完成的。</p>
<p>ApplicationBuilder是我们对所有实现了IApplicationBuilder接口的所有类型以及对应对象的统称。接口IApplicationBuilder定义如下，中间件的注册和RequestDelegate对象的生成分别通过调用它的Use和Build方法来完成。除了这两个核心方法，IApplicationBuilder接口还定义了三个属性，其中ApplicationServices返回根据最初服务注册生成的ServiceProvider对象，而ServerFeatures属性返回的FeatureCollection对象是描述Server的特性集合。字典类型的Properties属性用户存储任意自定义的属性，而New方法会根据自己“克隆”出一个新的ApplicationBuilder对象，这两个ApplicationBuilder对象应用具有相同的属性集合。</p>
<pre>   1: public interface IApplicationBuilder</pre>
<pre>   2: {</pre>
<pre>   3:     IServiceProvider             ApplicationServices { get; set; }</pre>
<pre>   4:     IFeatureCollection           ServerFeatures { get; }</pre>
<pre>   5:     IDictionary&lt;string, object&gt;  Properties { get; }</pre>
<pre>   6:  </pre>
<pre>   7:     RequestDelegate         Build();</pre>
<pre>   8:     IApplicationBuilder     New();</pre>
<pre>   9:     IApplicationBuilder     Use(Func&lt;RequestDelegate, RequestDelegate&gt; middleware);</pre>
<pre>  10: }</pre>
<p>具有如下定义的ApplicationBuilder类型是对IApplicationBuilder接口的默认实现。ApplicationBuilder类型利用一个List&lt;Func&lt;RequestDelegate,</p>
<p>RequestDelegate&gt;&gt;对象来保存注册的中间件，所以Use方法只需要将指定的中间件添加到这个列表中即可，而Build方法只需要逆序调用这些注册的中间件对应的Func&lt;RequestDelegate,</p>
<p>RequestDelegate&gt;对象就能得到我们需要的RequestDelegate对象。值得一提的是，Build方法实际上在中间件链条的尾部添加了一个额外的中间件，该中间件会负责将响应状态码设置为404，如果我们没有注册一个中间件对请求作最终的响应（这样的中间件将不会试图调用后续中间件），整个管道比较回复一个状态码为404的响应。</p>
<pre>   1: public class ApplicationBuilder : IApplicationBuilder</pre>
<pre>   2: {</pre>
<pre>   3:     private readonly IList&lt;Func&lt;RequestDelegate, RequestDelegate&gt;&gt; middlewares = new List&lt;Func&lt;RequestDelegate, RequestDelegate&gt;&gt;();</pre>
<pre>   4:  </pre>
<pre>   5:     public IDictionary&lt;string, object&gt; Properties { get; }</pre>
<pre>   6:  </pre>
<pre>   7:     public IServiceProvider ApplicationServices</pre>
<pre>   8:     {</pre>
<pre>   9:         get { return GetProperty&lt;IServiceProvider&gt;("application.Services"); }</pre>
<pre>  10:         set { SetProperty&lt;IServiceProvider&gt;("application.Services", value); }</pre>
<pre>  11:     }</pre>
<pre>  12:  </pre>
<pre>  13:     public IFeatureCollection ServerFeatures</pre>
<pre>  14:     {</pre>
<pre>  15:         get { return GetProperty&lt;IFeatureCollection&gt;("server.Features"); }</pre>
<pre>  16:     }</pre>
<pre>  17:  </pre>
<pre>  18:  </pre>
<pre>  19:     public ApplicationBuilder(IServiceProvider serviceProvider)</pre>
<pre>  20:     {</pre>
<pre>  21:         this.Properties = new Dictionary&lt;string, object&gt;();</pre>
<pre>  22:         ApplicationServices = serviceProvider;</pre>
<pre>  23:     }</pre>
<pre>  24:  </pre>
<pre>  25:     public ApplicationBuilder(IServiceProvider serviceProvider, object server)</pre>
<pre>  26:         : this(serviceProvider)</pre>
<pre>  27:     {</pre>
<pre>  28:         SetProperty("server.Features", server);</pre>
<pre>  29:     }</pre>
<pre>  30:  </pre>
<pre>  31:     public IApplicationBuilder Use(Func&lt;RequestDelegate, RequestDelegate&gt; middleware)</pre>
<pre>  32:     {</pre>
<pre>  33:         middlewares.Add(middleware);</pre>
<pre>  34:         return this;</pre>
<pre>  35:     }</pre>
<pre>  36:  </pre>
<pre>  37:     public IApplicationBuilder New()</pre>
<pre>  38:     {</pre>
<pre>  39:         return new ApplicationBuilder(this);</pre>
<pre>  40:     }</pre>
<pre>  41:  </pre>
<pre>  42:     public RequestDelegate Build()</pre>
<pre>  43:     {</pre>
<pre>  44:         RequestDelegate app = context =&gt;</pre>
<pre>  45:         {</pre>
<pre>  46:             context.Response.StatusCode = 404;</pre>
<pre>  47:             return Task.FromResult(0);</pre>
<pre>  48:         };</pre>
<pre>  49:         foreach (var component in middlewares.Reverse())</pre>
<pre>  50:         {</pre>
<pre>  51:             app = component(app);</pre>
<pre>  52:         }</pre>
<pre>  53:         return app;</pre>
<pre>  54: }</pre>
<pre>  55:  </pre>
<pre>  56:     private ApplicationBuilder(ApplicationBuilder builder)</pre>
<pre>  57:     {</pre>
<pre>  58:         this.Properties = builder.Properties;</pre>
<pre>  59:     }        </pre>
<pre>  60:  </pre>
<pre>  61:     private T GetProperty&lt;T&gt;(string key)</pre>
<pre>  62:     {</pre>
<pre>  63:         object value;</pre>
<pre>  64:         return Properties.TryGetValue(key, out value) ? (T)value : default(T);</pre>
<pre>  65:     }</pre>
<pre>  66:  </pre>
<pre>  67:     private void SetProperty&lt;T&gt;(string key, T value)</pre>
<pre>  68:     {</pre>
<pre>  69:         this.Properties[key] = value;</pre>
<pre>  70:     }</pre>
<pre>  71: }</pre>
<p>通过上面的代码片段我们不难看到，不论是通过ApplicationServices属性返回的ServiceProvider对象，还是通过ServerFeatures属性返回的用于描述Server特性的FeatureCollection对象，它们实际上都保存在通过Properties属性返回字典对象上。ApplicationBuilder具有两个公共构造函数重载，它们具有一个公共的参数，即用来初始化ApplicationServices属性的参数serviceProvider。</p>
<p>一个构造函数具有一个名为server的参数，但是这个参数并不是表示管道使用的服务器，而是承载服务器相关特性的FeatureCollection对象，不过这个参数类型被定义成Object，而不是IFeatureCollection接口。New方法直接调用私有构造函数创建出一个新的ApplicationBuilder对象，这个对象与自己的Properties属性共享同一个字典对象，由于ApplicationServices和ServerFeatures属性的返回值也存放在这个字典对象上，所以New方法得到的ApplicationBuilder对象与自身对象其实是完全等效的。</p>
<h2>ApplicationBuilderFactory</h2>
<p>ApplicationBuilderFactory是ASP.NET<br />
Core它用来创建ApplicationBuilder的工厂，它是对所有实现了接口IApplicationBuilderFactory的所有类型以及对应对象的统称。如下面的代码片段所示，该接口定义了唯一个方法CreateBuilder根据提供的FeatureCollection对象创建出对应的ApplicationBuilder对象，这个FeatureCollection对象正是承载与服务器相关特性的集合。ApplicationBuilderFactory类型是该接口的默认实现者，当CreateBuilder方法被调用的时候，它会直接将构造时提供ServiceProvider对象和serverFeatures参数表示的FeatureCollection对象来创建返回的ApplicationBuilder对象。</p>
<pre>   1: public interface IApplicationBuilderFactory</pre>
<pre>   2: {</pre>
<pre>   3:     IApplicationBuilder CreateBuilder(IFeatureCollection serverFeatures);</pre>
<pre>   4: }</pre>
<pre>   5:  </pre>
<pre>   6: public class ApplicationBuilderFactory : IApplicationBuilderFactory</pre>
<pre>   7: {</pre>
<pre>   8:     private readonly IServiceProvider _serviceProvider;</pre>
<pre>   9:  </pre>
<pre>  10:     public ApplicationBuilderFactory(IServiceProvider serviceProvider)</pre>
<pre>  11:     {</pre>
<pre>  12:         this._serviceProvider = serviceProvider;</pre>
<pre>  13:     }</pre>
<pre>  14:  </pre>
<pre>  15:     public IApplicationBuilder CreateBuilder(IFeatureCollection serverFeatures)</pre>
<pre>  16:     {</pre>
<pre>  17:         return new ApplicationBuilder(_serviceProvider, serverFeatures);</pre>
<pre>  18:     }</pre>
<pre>  19: }</pre>
<h2>中间件类型</h2>
<p>虽然中间件最终体现为一个类型为 Func&lt;RequestDelegate,<br />
RequestDelegate&gt;的委托对象，但是我们在大部分情况下都会将中间件定义成一个单独的类型。虽然这样的中间件类型不要求实现某个预定义的接口或者继承某个预定义的基类，但是却要遵守几个必要的约定。接下来我们直接如下这个ContentMiddleware类说说一个合法的中间件类型应该如何定义。</p>
<pre>   1: public class ContentMiddleare</pre>
<pre>   2: {</pre>
<pre>   3:     public RequestDelegate     _next;</pre>
<pre>   4:     public byte[]         _content;</pre>
<pre>   5:     public string         _contentType;</pre>
<pre>   6:  </pre>
<pre>   7:     public ContentMiddleare(RequestDelegate next, byte[] content, string contentType)</pre>
<pre>   8:     {</pre>
<pre>   9:         _next         = next;</pre>
<pre>  10:         _content      = content;</pre>
<pre>  11:         _contentType  = contentType;</pre>
<pre>  12:     }</pre>
<pre>  13:  </pre>
<pre>  14:     public async Task Invoke(HttpContext context, ILoggerFactory loggerFactory)</pre>
<pre>  15:     {</pre>
<pre>  16:         loggerFactory.CreateLogger&lt;ContentMiddleare&gt;().LogInformation($"Write content ({_contentType})");</pre>
<pre>  17:         context.Response.ContentType = _contentType;</pre>
<pre>  18:         await context.Response.Body.WriteAsync(_content,0, _content.Length);</pre>
<pre>  19:     }</pre>
<pre>  20: }</pre>
<p>如上所示的这个中间件(ContentMiddleware)可以帮助我们将任何类型的内容响应给客户端，它的两个字段_content和_contentType分别代表响应内容和媒体类型（内容类型或者MIME类型），它体现了一个典型中间件类型的定义规则或者约定：</p>
<ul>
<li>应该定义成实例类，不能定义成静态类。</li>
<li>具有一个有效的公共构造函数。这个构造函数的第一个参数类型必须为RequestDelegate，代表对请求的后续操作（可以视为下一个注册的中间件），至于后续参数的个数和类型则不作要求。</li>
<li>针对请求的处理定义在一个名为Invoke的公共实例方法，其返回类型为Task。该方法的第一个参数类型为HttpContext，代表当前HTTP上下文。我们可以为这个方法定义任意数量和类型的后续参数，当这个方法被执行的时候，系统将会采用依赖注入的方式提供响应的服务来为这个参数赋值。</li>
</ul>
<h2>中间件类型的注册</h2>
<p>中间件类型的注册可以通过调用 IApplicationBuilder接口的扩展方法UseMiddleware 和UseMiddleware<br />
&lt;<br />
 TMiddleware<br />
&gt;进行注册。如下面的代码片断所示，除了指定中间件的类型之外，我们还需要按照顺序指定调用目标构造函数的全部或者部分参数。不过不过的参数列表不需要提供作为第一个参数的RequestDelegate，如果仅仅指定了部分参数，缺失的参数将会自动通过ServiceProvider来提供。</p>
<pre>   1: public static class UseMiddlewareExtensions</pre>
<pre>   2: {</pre>
<pre>   3:     public static IApplicationBuilder UseMiddleware&lt;TMiddleware&gt;(this IApplicationBuilder app, params object[] args);</pre>
<pre>   4:     public static IApplicationBuilder UseMiddleware(this IApplicationBuilder app, Type middleware, params object[] args);</pre>
<pre>   5: }</pre>
<p>对于上面定义的这个 ContentMiddleare类型，我们按照如下的方式对它进行了注册。当这个中间件执行的时候，它会响应客户端一张PNG图片。如果客户端是能够支持图片呈现的浏览器，这张图片会直接显示在浏览器上。</p>
<pre>   1: new WebHostBuilder()</pre>
<pre>   2:     .Configure(app=&gt;app.UseMiddleware&lt;ContentMiddleare&gt;(File.ReadAllBytes("girl.png"),"image/png"))</pre>
<pre>   3: ...</pre>
<p>虽然中间件可以定义成任何一个遵循约定的类型，但是中间件自身在ASP.NET<br />
Core框架中总是体现为一个类型为Func&lt;RequestDelegate,<br />
RequestDelegate&gt;的委托对象，所以上述的这个UseMiddleware方法在执行的时候需要在内部根据注册的中间件类型和指定的参数列表创建这么一个Func&lt;RequestDelegate,</p>
<p>RequestDelegate&gt;对象。其中的逻辑并不复杂，它之需要将中间件对象的创建和针对Invoke方法的调用实现在返回的委托对象中就可以了。值得一提的是，针对Invoke方法的调用并没有直接通过反射的方式来实现，而是采用表达式，后者具有更好的性能。在如下所示的代码片段中，我采用最精简的代码模拟了UseMiddleware方法的实现。</p>
<pre>   1: public static class WebHostBuilderExtensions</pre>
<pre>   2: {</pre>
<pre>   3:     private static MethodInfo GetServiceMethod = typeof(WebHostBuilderExtensions).GetMethod("GetService", BindingFlags.Static | BindingFlags.NonPublic);</pre>
<pre>   4:  </pre>
<pre>   5:     public static IApplicationBuilder UseMiddleware&lt;TMiddleware&gt;(this IApplicationBuilder app, params object[] args)</pre>
<pre>   6:     {</pre>
<pre>   7:         return UseMiddleware2(app, typeof(TMiddleware), args);</pre>
<pre>   8:     }</pre>
<pre>   9:  </pre>
<pre>  10:     public static IApplicationBuilder UseMiddleware(this IApplicationBuilder app, Type middlewareType, params object[] args)</pre>
<pre>  11:     {</pre>
<pre>  12:         return app.Use(next =&gt;</pre>
<pre>  13:         {</pre>
<pre>  14:             return context =&gt; {</pre>
<pre>  15:                 var factory = Compile&lt;object&gt;(middlewareType.GetMethod("Invoke", BindingFlags.Instance | BindingFlags.Public));</pre>
<pre>  16:                 object middleware = CreateMiddleware(app, middlewareType, next, args);</pre>
<pre>  17:                 return factory(middleware, context, app.ApplicationServices);</pre>
<pre>  18:             };              </pre>
<pre>  19:         });</pre>
<pre>  20:     }</pre>
<pre>  21:  </pre>
<pre>  22:     private static object CreateMiddleware(IApplicationBuilder app, Type middlewareType, RequestDelegate next, params object[] args)</pre>
<pre>  23:     {</pre>
<pre>  24:         object[] arguments = new object[args.Length + 1];</pre>
<pre>  25:         arguments[0] = next;</pre>
<pre>  26:         args.CopyTo(arguments, 1);</pre>
<pre>  27:         return ActivatorUtilities.CreateInstance(app.ApplicationServices, middlewareType, arguments);</pre>
<pre>  28:     }</pre>
<pre>  29:     </pre>
<pre>  30:     //将对Invoke方法的调用转换成一个Func&lt;TMiddleware, HttpContext, IServiceProvider, Task&gt;对象</pre>
<pre>  31:     private static Func&lt;TMiddleware, HttpContext, IServiceProvider, Task&gt; Compile&lt;TMiddleware&gt;(MethodInfo invokeMethod)</pre>
<pre>  32:     {           </pre>
<pre>  33:         ParameterExpression middleware = Expression.Parameter(typeof(TMiddleware), "middleware");</pre>
<pre>  34:         ParameterExpression httpContext = Expression.Parameter(typeof(HttpContext), "httpContext");</pre>
<pre>  35:         ParameterExpression serviceProvider = Expression.Parameter(typeof(IServiceProvider), "serviceProvider");</pre>
<pre>  36:  </pre>
<pre>  37:         var arguments = from parameter in invokeMethod.GetParameters()</pre>
<pre>  38:             select GetArgument(httpContext, serviceProvider, parameter.ParameterType);</pre>
<pre>  39:  </pre>
<pre>  40:         Expression instance = middleware;</pre>
<pre>  41:         if (invokeMethod.DeclaringType != typeof(TMiddleware))</pre>
<pre>  42:         {</pre>
<pre>  43:             instance = Expression.Convert(instance, invokeMethod.DeclaringType);</pre>
<pre>  44:         }</pre>
<pre>  45:  </pre>
<pre>  46:         Expression invoke = Expression.Call(instance, invokeMethod, arguments.ToArray());</pre>
<pre>  47:         return Expression.Lambda&lt;Func&lt;TMiddleware, HttpContext, IServiceProvider, Task&gt;&gt;(invoke, middleware, httpContext, serviceProvider).Compile();</pre>
<pre>  48:     }</pre>
<pre>  49:     </pre>
<pre>  50:     //生成调用Invoke方法的参数表达式</pre>
<pre>  51:     private static Expression GetArgument(Expression httpContext, Expression serviceProvider, Type parameterType)</pre>
<pre>  52:     {</pre>
<pre>  53:         if (parameterType == typeof(HttpContext))</pre>
<pre>  54:         {</pre>
<pre>  55:             return httpContext;</pre>
<pre>  56:         }</pre>
<pre>  57:         Expression serviceType = Expression.Constant(parameterType, typeof(Type));</pre>
<pre>  58:         Expression callGetService = Expression.Call(GetServiceMethod, serviceProvider, serviceType);</pre>
<pre>  59:         return Expression.Convert(callGetService, parameterType);</pre>
<pre>  60:     }</pre>
<pre>  61:  </pre>
<pre>  62:     private static object GetService(IServiceProvider serviceProvider, Type serviceType)</pre>
<pre>  63:     {</pre>
<pre>  64:         return serviceProvider.GetService(serviceType);</pre>
<pre>  65:     }</pre>
<pre>  66: }</pre>
<p>作者：蒋金楠 <br />
微信公众账号：大内老A<br />
微博：<a href="http://www.weibo.com/artech" rel="external nofollow noreferrer">www.weibo.com/artech</a><br />
如果你想及时得到个人撰写文章以及著作的消息推送，或者想看看个人推荐的技术资料，可以扫描左边二维码（或者长按识别二维码）关注个人公众号（原来公众帐号蒋金楠的自媒体将会停用）。<br />
本文版权归作者和博客园共有，欢迎转载，但未经作者同意必须保留此段声明，且在文章页面明显位置给出原文连接，否则保留追究法律责任的权利。</p>
<p><a href="http://www.cnblogs.com/artech/p/asp-net-core-real-pipeline-01.html" rel="external nofollow noreferrer">原文链接</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 02:25:21</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/core/" title="core">core</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/asp/" title="asp">asp</a>, <a href="https://www.iamivan.net/tag/%e4%b8%ad%e9%97%b4%e4%bb%b6/" title="中间件">中间件</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>学习ASP.NET Core,怎能不了解请求处理管道[1]: 中间件究竟是个什么东西？的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr2xovM.html" rel="bookmark">学习ASP&period;NET Core&comma; 怎能不了解请求处理管道&lbrack;5&rsqb;&colon; 中间件注册可以除了可以使用Startup之外，还可以选择StartupFilter</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中间件的注册除了可以借助Startup对象(DelegateStartup或者ConventionBasedStartup)来完成之外,也可以利用另一个叫做StartupFilter的对象来实现.所谓的StartupFilter是对所有实现了IStartupFilter接口的类型及其对象的统称.IStartupFilter接口定义了如下一个唯一的方法Configure,该方法的参数next返回的Action&lt;IApplicationBuilder&gt;对象体现了后续StartupFilter和St			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRqJGp.html" rel="bookmark">学习ASP&period;NET Core&comma; 怎能不了解请求处理管道&lbrack;6&rsqb;&colon; 管道是如何随着WebHost的开启被构建出来的？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				注册的服务器和中间件共同构成了ASP.NET Core用于处理请求的管道, 这样一个管道是在我们启动作为应用宿主的WebHost时构建出来的.要深刻了解这个管道是如何被构建出来的,我们就必须对WebHost和它的创建者WebHostBuilder这个重要的对象具有深刻的理解.[本文已经同步到&lt;ASP.NET Core框架揭秘&gt;之中] 目录 一.WebHost     WebHostOptions     构建管道的三个步骤 二.WebHostBuilder     WebHost的创建    			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnK93Zz.html" rel="bookmark">学习ASP&period;NET Core&comma; 怎能不了解请求处理管道&lbrack;3&rsqb;&colon; 自定义一个服务器感受一下管道是如何监听、接收和响应请求的</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们在&lt;服务器在管道中的&quot;龙头&quot;地位&gt;中对ASP.NET Core默认提供的具有跨平台能力的KestrelServer进行了介绍,为了让读者朋友们对管道中的服务器具有更加深刻的认识,接下来我们采用实例演示的形式创建一个自定义的服务器.这个自定义的服务器直接利用HttpListener来完成针对请求的监听.接收和响应,我们将其命名为HttpListenerServer.在正式介绍HttpListenerServer的设计和实现之前,我们先来显示一下如何将它应用到 一个具体的W			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwW09nz.html" rel="bookmark">学习ASP&period;NET Core&comma; 怎能不了解请求处理管道&lbrack;4&rsqb;&colon; 应用的入口&mdash;&mdash;Startup</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一个ASP.NET Core应用被启动之后就具有了针对请求的处理能力,而这个能力是由管道赋予的,所以应用的启动同时意味着管道的成功构建.由于管道是由注册的服务器和若干中间件构成的,所以应用启动过程中一个核心的工作就是完成中间节的注册.由于依赖注入在ASP.NET Core应用这得到非常广泛的应用,框架绝大部分的工作都会分配给我们预先注册的服务,所以服务注册也是启动WebHost过程的另一项核心工作.这两项在启动过程中必须完成的核心工作通过一个名为Startup的对象来承载. [本文已经同步到&lt;A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkAe77b.html" rel="bookmark">学习ASP&period;NET Core&comma;怎能不了解请求处理管道&lbrack;2&rsqb;&colon; 服务器在管道中的&OpenCurlyDoubleQuote;龙头&rdquo;地位</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ASP.NET Core管道由注册的服务器和一系列中间件构成.我们在上一篇中深入剖析了中间件,现在我们来了解一下服务器.服务器是ASP .NET Core管道的第一个节点,它负责完整请求的监听和接收,最终对请求的响应同样也由它完成.[本文已经同步到&lt;ASP.NET Core框架揭秘&gt;之中] 服务器是我们对所有实现了IServer接口的所有类型以及对应对象的统称.如下面的代码片段所示,这个接口具有一个只读属性Features返回描述自身特性集合的FeatureCollection对象,另一个St			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvmOW5b.html" rel="bookmark">学习ASP&period;NET Core，你必须了解无处不在的&OpenCurlyDoubleQuote;依赖注入&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ASP.NET Core的核心是通过一个Server和若干注册的Middleware构成的管道,不论是管道自身的构建,还是Server和Middleware自身的实现,以及构建在这个管道的应用,都需要相应的服务提供支持,ASP.NET Core自身提供了一个DI容器来实现针对服务的注册和消费.换句话说,不只是ASP.NET Core底层框架使用的服务是由这个DI容器来注册和提供,应用级别的服务的注册和提供也需要以来这个DI容器,所以正如本文标题所说的--学习ASP.NET Core,你必须了解无			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQm98p.html" rel="bookmark">ASP&period;NET Core应用的错误处理&lbrack;2&rsqb;：DeveloperExceptionPageMiddleware中间件如何呈现&OpenCurlyDoubleQuote;开发者异常页面&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在&lt;ASP.NET Core应用的错误处理[1]:三种呈现错误页面的方式&gt;中,我们通过几个简单的实例演示了如何呈现一个错误页面,这些错误页面的呈现分别由三个对应的中间件来完成,接下来我们将对这三个中间件进行详细介绍.在开发环境呈现的异常页面是通过一个类型为DeveloperExceptionPageMiddleware中间件实现的.[本文已经同步到&lt;ASP.NET Core框架揭秘&gt;之中] 1: public class DeveloperExceptionPageMiddlewa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrXNnWz.html" rel="bookmark">ASP&period;NET Core应用的错误处理&lbrack;3&rsqb;：ExceptionHandlerMiddleware中间件如何呈现&OpenCurlyDoubleQuote;定制化错误页面&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				DeveloperExceptionPageMiddleware中间件利用呈现出来的错误页面实现抛出异常和当前请求的详细信息以辅助开发人员更好地进行纠错诊断工作,而ExceptionHandlerMiddleware中间件则是面向最终用户的,我们可以利用它来显示一个友好的定制化的错误页面.按照惯例,我们还是先来看看ExceptionHandlerMiddleware的类型定义. [本文已经同步到&lt;ASP.NET Core框架揭秘&gt;之中] 1: public class ExceptionHan			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlK6n8b.html" rel="bookmark">ASP&period;NET Core应用的错误处理&lbrack;4&rsqb;：StatusCodePagesMiddleware中间件如何针对响应码呈现错误页面</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				StatusCodePagesMiddleware中间件与ExceptionHandlerMiddleware中间件比较类似,它们都是在后续请求处理过程中&quot;出错&quot;的情况下利用一个错误处理器来完成最终的请求处理与响应的任务.它们之间的差异在于对&quot;错误&quot;的界定上,对于ExceptionHandlerMiddleware中间件来说,它所谓的错误就是抛出异常,但是对于StatusCodePagesMiddleware中间件来说,则将介于400~599之间的响应状态码视为错误			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz41wjb.html" rel="bookmark" class="title">按比例微缩图片的一段小小的JS代码</a>
					<div>
						js          自己写的一个非常简单的图片微缩JS代码,当然网上有很多类似的代码,在此确实是献丑了.         主要方法写在SetImgSize.js里面 SetImgSize.js 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNdX4z.html" rel="bookmark" class="title">网站优化公司内幕</a>
					<div>
						企业经常会接到陌生人打来的电话,说您的网站需要优化么,我们是网络公司的,我们一个月内就会把你企业的关键词排到首页,价钱不是很贵,每个月也就1000多元,一年也就一万多快,包年我们还可以给你打个折.而大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOARvM.html" rel="bookmark" class="title">全面接触SQL语法2</a>
					<div>
						sql语法 BETWEEN...AND 运算符 决定某一人数值是否介于特定的范围之内,此运算符只可以用在SQL的语句中. expr[Not]BETWEEN value1 AND value2 expr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJggwb.html" rel="bookmark" class="title">新浪微博和腾讯微薄的注册与新用户引导流程</a>
					<div>
						前言 最近微博很火热,以新浪微博和腾讯微博为代表,体现了不同的产品设计理念. 新浪保持了一贯的媒体路线,腾讯仍希望发挥出草根们的强大动能. 对于两家互联网大公司的微博产品,在下不才进行了一些观察,不敢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7d6NM.html" rel="bookmark" class="title">与众不同windows phone &lpar;20&rpar;</a>
					<div>
						Device(设备)之位置服务(GPS 定位), FM 收音机, 麦克风, 震动器 介绍 与众不同 windows phone 7.5 (sdk 7.1) 之设备 位置服务(GPS 定位) FM 收音 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1DkEz.html" rel="bookmark" class="title">&period;NET Framework 4&period;0 Beta1里的Expression Tree一例</a>
					<div>
						既然装上了Visual Studio 2010 Beta 1,正好可以试试.NET Framework 4.0里的一些新东西.我比较关注的是Expression Tree的部分,到底哪些功能进到了.N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxrJjb.html" rel="bookmark" class="title">ps抽出滤镜使用教程</a>
					<div>
						Photoshop抽出可以将对象与其背景分离,无论对象的边缘是多么细微和复杂,使用抽出命令都能够得到满意的效果.主要步骤为先标记出对象的边缘并对要保留的部分进行填充,可以进行预览,然后对抽出的效果进行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7Aq6M.html" rel="bookmark" class="title">阻止Windows8系统自动清理缩略图信息的方法</a>
					<div>
						在Windows8系统新式的用户界面以及针对平板电脑的优化给用户留下的深刻的印象.实际上,Windows8也使用了新的网络设置,个性化管理,系统登录以及系统安全的相关选项.同之前版本的Windows系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKkdEM.html" rel="bookmark" class="title">photoshop打造七彩闪亮的透明玻璃文字效果</a>
					<div>
						  国外设计师用photoshop打造七彩闪亮的透明玻璃文字效果,非常赞的效果,而且简单粗暴,有好多的地方可以借鉴来用,有兴趣的可以试试 分类: PS文字教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42yjrM.html" rel="bookmark" class="title">Linux下的vps被ddos攻击的解决办法</a>
					<div>
						  连接vps 输入第一个命令 netstat -anp |awk '{print $6}'|sort|uniq -c |sort -rn 这里我们查看SYN_RECV这些,看他的连接数高不高,好几百 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQN1qZM.html" rel="bookmark" class="title">excel下拉菜单怎么做</a>
					<div>
						  第一步:打开excel2010,以次选择&quot;数据&quot;项下方&quot;数据有效性&quot;如下图例: 第二步:在&quot;允许&quot;下框中选择&quot;序列&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZd14BM.html" rel="bookmark" class="title">呱呱视频社区怎么看不到公屏信息？</a>
					<div>
						  呱呱视频社区怎么看不到公屏信息?一些呱呱视频社区的房间都会把最新的房间活动发布在公公屏上,不过,一些呱呱视频社区用户表示:呱呱视频社区看不到公屏信息,或者说公屏信息不显示.那么,呱呱视频社区怎么会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAr1Aep.html" rel="bookmark" class="title">WinXP开机显示粉红色之后恢复进入桌面是怎么回事</a>
					<div>
						  关于这个问题我们可以分为两种原因: 1.显示器连接线接触不良,导致颜色异常;可以检查显示器的链接接头是否松脱. 2. 系统运行信号中的Garbage;一般这样的信号会被系统屏蔽,用户是看不到的.可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWw40p.html" rel="bookmark" class="title">gui-怎么用IntelliJ IDEA  GUI生成源码&quest;</a>
					<div>
						问题描述 怎么用IntelliJ IDEA GUI生成源码? 画完表单后source没反应啊~为什么呢~求大神解答~ 解决方案 http://jdev.tw/blog/3823/intellij-id ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJk63wb.html" rel="bookmark" class="title">sql-麻烦大家给我看下这个SQL语句出现了什么问题，谢谢！</a>
					<div>
						问题描述 麻烦大家给我看下这个SQL语句出现了什么问题,谢谢! select grade,cno=2 from sc group by cno having count(grade)&gt;=90 - ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Pev4p.html" rel="bookmark" class="title">c&plus;&plus;-这个 shared&lowbar;ptr 在使用的时候为什么要 reset？</a>
					<div>
						问题描述 这个 shared_ptr 在使用的时候为什么要 reset? class Query_result; class Text_query { public: using line_no =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRD89Kz.html" rel="bookmark" class="title">iOS逆向工程&mdash;&mdash;非越狱调试</a>
					<div>
						其实iOS的逆向分析业界已经十分成熟了,网上也有许多有趣的尝试(一步一步实现iOS微信自动抢红包(非越狱).本文着重于如何在非越狱机器上进行调试,出于学习及总结的目的,记录于此. 本文以破解游戏梦幻西 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydZWkb.html" rel="bookmark" class="title">PS合成漫天萤火虫效果</a>
					<div>
						PS合成漫天萤火虫效果  近年开始流行拍摄萤火虫,有些场景的萤火虫密度并不如人意,这时我们通过后期堆栈技术来表现无数萤火虫漫天飞舞的意境. 我们要解决的问题: 1.萤火虫太少,如何弥补; 2.什么是堆 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRoN6b.html" rel="bookmark" class="title">SQL Server 2008开启sa用户名和远程连接</a>
					<div>
						sql server 2008默认是不允许远程连接的,sa帐户默认禁用的,如果想要在本地用SSMS连接远程服务器上的SQL Server 2008,需要做两个部分的配置:1,SQL Server Ma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKn8vb.html" rel="bookmark" class="title">关于livtview中绑定数据源selectcommand重载的问题</a>
					<div>
						问题描述 本人做了一个在线考试的系统,里面对选择题项目采用listview读取.数据库中的题干和选项,且DataPager采用单项分页.数据源使用的是access数据库.我把accesss数据库的se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKeyab.html" rel="bookmark" class="title">美团云李爽：坚持&OpenCurlyDoubleQuote;三高三低&rdquo;原则，为成长型企业赋能</a>
					<div>
						近日,美团云在其媒体开放日期间,面向行业内外媒体发布了全新的品牌logo及品牌口号.美团云宣称,其将在未来几年时间内致力于为全中国广大成长型企业赋能,并成为业内主流的云计算服务提供商. 美团点评做云, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBgQwz.html" rel="bookmark" class="title">《Photoshop修饰与合成专业技法》&mdash;第1章钢笔工具</a>
					<div>
						钢笔工具 不用怀疑,要想建立干净.整齐的选区,最好的办法就是使用钢笔工具. 我不是在谈论选择头发,因为有很多其他的方法更适合建立头发的选区.但是当你想要选择一些带有直线和曲线的东西时,没有什么比钢笔工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnJ3oM.html" rel="bookmark" class="title">Windows 10 评测：用完了想直接换Mac</a>
					<div>
						Windows 10 S硬件的竞争对手是谷歌Chromebook,希望蚕食Chromebook在教育市场上的销售,但它存在的诸多不便之处,给用户带来很大麻烦. 据PCWorld 网站报道,Window ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjw566M.html" rel="bookmark" class="title">1号店Interview小结</a>
					<div>
						Schema:可以理解为是一种约束,一个规则.表结构就一种schema 三大范式: 为了建立冗余较小.结构合理的数据库,设计数据库时必须遵循一定的规则.在关系型数据库中这种规则就称为范式.范式是符合某 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRQ7rp.html" rel="bookmark" class="title">DataTable 排序  问题 C&num;</a>
					<div>
						问题描述 现有一表栏位如下:ABCDabcd怎么把它转化为以下顺序:AaBbCcDd 解决方案 解决方案二:没有现成的方法,只有自己逐个处理.解决方案三:复制datatable,先复制表结构,复制数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNQxKM.html" rel="bookmark" class="title">&lowbar;&lowbar;attribute&lowbar;&lowbar;&lpar;&lpar;aligned&lpar;n&rpar;&rpar;&rpar;的使用</a>
					<div>
						问题描述 __attribute__((aligned(n)))的使用 attribute((aligned(n)))改变结构体对其方式怎么使用 为何在VS2005里面编译通过不了,aligned关键 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYjkNb.html" rel="bookmark" class="title">jQuery&plus;jsp下拉框联动获取本地数据的方法&lpar;附源码&rpar;&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery+jsp下拉框联动获取本地数据的方法.分享给大家供大家参考,具体如下: JQuery下拉框联动很好的体现了Ajax的按需取数据的要求,减小数据的交互量.(点击此处下载源代码) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOn74Qp.html" rel="bookmark" class="title">ios-有关IOS使用ARC开发问题</a>
					<div>
						问题描述 有关IOS使用ARC开发问题 想问一个特别弱的问题,如果在一个循环中创建的对象什么时候被release. ARC中. while(true){ NSData *data = [NSData  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEG0mz.html" rel="bookmark" class="title">C&num;&plus;mapxtreme 怎么实现地图 闪亮</a>
					<div>
						问题描述 如题:我电子地图已经做好,电子地图有线路图层,已经导入页面,怎么编程,可以查询线路时同时闪亮地图中的线路呢 解决方案 解决方案二:怎么没有人呢,是不是分太少了啊!解决方案三:一个就是把查询的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZmW0Op.html" rel="bookmark" class="title">聚焦&OpenCurlyDoubleQuote;两会&rdquo; 人脸识别让安防不止于安全</a>
					<div>
						中共中央政治局委员.中央政法委书记孟建柱此前在北京市调研时指出,做好全国两会安保工作是一项重要政治任务.要切实增强大局意识.责任意识,把困难想得多一些,把问题研究得透一些,把工作考虑得细致一些,努力补 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.074 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
